Index: .gitignore
===================================================================
--- .gitignore	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ .gitignore	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -110,5 +110,4 @@
 uspace/app/init/init
 uspace/app/init/init.gz
-uspace/app/lprint/lprint
 uspace/app/kill/kill
 uspace/app/killall/killall
@@ -134,4 +133,6 @@
 uspace/app/ping6/ping6
 uspace/app/pkg/pkg
+uspace/app/rcubench/rcubench
+uspace/app/rcutest/rcutest
 uspace/app/redir/redir
 uspace/app/sbi/sbi
@@ -210,4 +211,6 @@
 uspace/dist/app/ping6
 uspace/dist/app/pkg
+uspace/dist/app/rcubench
+uspace/dist/app/rcutest
 uspace/dist/app/redir
 uspace/dist/app/sbi
@@ -311,5 +314,4 @@
 uspace/drv/char/msim-con/msim-con
 uspace/drv/char/ns8250/ns8250
-uspace/drv/char/pc-lpt/pc-lpt
 uspace/drv/char/pl050/pl050
 uspace/drv/char/ps2mouse/ps2mouse
Index: abi/doc/doxygroups.h
===================================================================
--- abi/doc/doxygroups.h	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ abi/doc/doxygroups.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -50,5 +50,5 @@
 
 /**
- * @defgroup abi_riscv64 riscv64
+ * @defgroup abi_riscv5 riscv5
  * @ingroup abi
  */
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ boot/Makefile.common	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -183,5 +183,4 @@
 	killall \
 	loc \
-	lprint \
 	mixerctl \
 	modplay \
@@ -193,4 +192,6 @@
 	nic \
 	perf \
+	rcutest \
+	rcubench \
 	sbi \
 	sportdmp \
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ boot/arch/amd64/Makefile.inc	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -46,5 +46,4 @@
 	audio/hdaudio \
 	char/ns8250 \
-	char/pc-lpt \
 	time/cmos-rtc \
 	bus/usb/ehci\
Index: contrib/qemu/build-from-scratch.sh
===================================================================
--- contrib/qemu/build-from-scratch.sh	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ contrib/qemu/build-from-scratch.sh	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -29,5 +29,5 @@
 #
 
-VERSION=3.1.0
+VERSION=3.0.0
 BASENAME=qemu-${VERSION}
 BASENAME_MASTER=qemu-master
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/Makefile	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -162,4 +162,5 @@
 GENERIC_SOURCES = \
 	generic/src/adt/bitmap.c \
+	generic/src/adt/btree.c \
 	generic/src/adt/hash_table.c \
 	generic/src/adt/list.c \
@@ -278,4 +279,5 @@
 		test/test.c \
 		test/atomic/atomic1.c \
+		test/btree/btree1.c \
 		test/fault/fault1.c \
 		test/mm/falloc1.c \
@@ -312,4 +314,5 @@
 ifeq ($(CONFIG_TRACE),y)
 	INSTRUMENTED_SOURCES = \
+		generic/src/adt/btree.c \
 		generic/src/cpu/cpu.c \
 		generic/src/ddi/ddi.c \
Index: kernel/arch/arm32/include/arch/context.h
===================================================================
--- kernel/arch/arm32/include/arch/context.h	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/arch/arm32/include/arch/context.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -40,5 +40,4 @@
 #include <arch/stack.h>
 #include <arch/context_struct.h>
-#include <arch/regutils.h>
 
 /* Put one item onto the stack to support get_stack_base() and align it up. */
@@ -50,5 +49,4 @@
 		(c)->sp = ((uintptr_t) (stack)) + (size) - SP_DELTA; \
 		(c)->fp = 0; \
-		(c)->cpu_mode = SUPERVISOR_MODE; \
 	} while (0)
 
Index: kernel/arch/sparc64/src/sun4v/start.S
===================================================================
--- kernel/arch/sparc64/src/sun4v/start.S	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/arch/sparc64/src/sun4v/start.S	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -162,7 +162,7 @@
 
 	! map kernel in context 1
-	set kernel_load_address, %o0				! virt. address
+	set kernel_image_start, %o0				! virt. address
 	set 1, %o1						! context
-	TTE_DATA(kernel_load_address, %l5, %g2, %g3, %o2)	! TTE data
+	TTE_DATA(kernel_image_start, %l5, %g2, %g3, %o2)	! TTE data
 	set MMU_FLAG_DTLB | MMU_FLAG_ITLB, %o3			! MMU flags
 	__HYPERCALL_HYPERFAST(MMU_MAP_ADDR)
@@ -181,7 +181,7 @@
 
 	! install permanent mapping for kernel in context 0
-	set kernel_load_address, %o0				! virtual address
+	set kernel_image_start, %o0				! virtual address
 	set 0, %o1						! context
-	TTE_DATA(kernel_load_address, %l5, %g2, %g3, %o2)	! TTE data
+	TTE_DATA(kernel_image_start, %l5, %g2, %g3, %o2)	! TTE data
 	set MMU_FLAG_DTLB | MMU_FLAG_ITLB, %o3			! MMU flags
 	__HYPERCALL_FAST(MMU_MAP_PERM_ADDR)
Index: kernel/genarch/src/multiboot/multiboot.c
===================================================================
--- kernel/genarch/src/multiboot/multiboot.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/genarch/src/multiboot/multiboot.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -55,8 +55,8 @@
 	/*
 	 * Find last occurence of '/' before 'end'. If found, place start at
-	 * next character. Otherwise, place start at beginning of command line.
+	 * next character. Otherwise, place start at beginning of buffer.
 	 */
 	const char *cp = end;
-	const char *start = cmd_line;
+	const char *start = buf;
 
 	while (cp != start) {
Index: kernel/generic/include/adt/btree.h
===================================================================
--- kernel/generic/include/adt/btree.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
+++ kernel/generic/include/adt/btree.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -0,0 +1,117 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_generic_adt
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_BTREE_H_
+#define KERN_BTREE_H_
+
+#include <adt/list.h>
+#include <stddef.h>
+
+#define BTREE_M		5
+#define BTREE_MAX_KEYS	(BTREE_M - 1)
+
+typedef uint64_t btree_key_t;
+
+/** B-tree node structure. */
+typedef struct btree_node {
+	/** Number of keys. */
+	size_t keys;
+
+	/**
+	 * Keys. We currently support only single keys. Additional room for one
+	 * extra key is provided.
+	 */
+	btree_key_t key[BTREE_MAX_KEYS + 1];
+
+	/**
+	 * Pointers to values. Sorted according to the key array. Defined only in
+	 * leaf-level. There is room for storing value for the extra key.
+	 */
+	void *value[BTREE_MAX_KEYS + 1];
+
+	/**
+	 * Pointers to descendants of this node sorted according to the key
+	 * array.
+	 *
+	 * subtree[0] points to subtree with keys lesser than to key[0].
+	 * subtree[1] points to subtree with keys greater than or equal to
+	 *	      key[0] and lesser than key[1].
+	 * ...
+	 * There is room for storing a subtree pointer for the extra key.
+	 */
+	struct btree_node *subtree[BTREE_M + 1];
+
+	/** Pointer to parent node. Root node has NULL parent. */
+	struct btree_node *parent;
+
+	/**
+	 * Link connecting leaf-level nodes. Defined only when this node is a
+	 * leaf.
+	 */
+	link_t leaf_link;
+
+	/* Variables needed by btree_print(). */
+	link_t bfs_link;
+	int depth;
+} btree_node_t;
+
+/** B-tree structure. */
+typedef struct {
+	btree_node_t *root;	/**< B-tree root node pointer. */
+	list_t leaf_list;	/**< List of leaves. */
+} btree_t;
+
+extern void btree_init(void);
+
+extern void btree_create(btree_t *t);
+extern void btree_destroy(btree_t *t);
+
+extern void btree_insert(btree_t *t, btree_key_t key, void *value,
+    btree_node_t *leaf_node);
+extern void btree_remove(btree_t *t, btree_key_t key, btree_node_t *leaf_node);
+extern void *btree_search(btree_t *t, btree_key_t key, btree_node_t **leaf_node);
+
+extern btree_node_t *btree_leaf_node_left_neighbour(btree_t *t,
+    btree_node_t *node);
+extern btree_node_t *btree_leaf_node_right_neighbour(btree_t *t,
+    btree_node_t *node);
+
+extern void btree_print(btree_t *t);
+
+extern unsigned long btree_count(btree_t *t);
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/generic/include/mm/as.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -45,4 +45,5 @@
 #include <synch/mutex.h>
 #include <adt/list.h>
+#include <adt/btree.h>
 #include <adt/odict.h>
 #include <lib/elf.h>
@@ -136,48 +137,4 @@
 } as_operations_t;
 
-/** Single anonymous page mapping. */
-typedef struct {
-	/** Containing pagemap structure */
-	struct as_pagemap *pagemap;
-	/** Link to @c shinfo->pagemap ordered dictionary */
-	odlink_t lpagemap;
-	/** Virtual address */
-	uintptr_t vaddr;
-	/** Physical frame address */
-	uintptr_t frame;
-} as_page_mapping_t;
-
-/** Map of anonymous pages in a shared area. */
-typedef struct as_pagemap {
-	/**
-	 * Dictionary ordered by virtual address. Members are of type
-	 * as_page_mapping_t
-	 */
-	odict_t map;
-} as_pagemap_t;
-
-/** Used space interval */
-typedef struct {
-	/** Containing used_space structure */
-	struct used_space *used_space;
-	/** Link to @c used_space->ivals */
-	odlink_t lused_space;
-	/** First page address */
-	uintptr_t page;
-	/** Count of pages */
-	size_t count;
-} used_space_ival_t;
-
-/** Map of used space in an address space area */
-typedef struct used_space {
-	/**
-	 * Dictionary of intervals by start address.
-	 * Members are of type @c used_space_ival_t.
-	 */
-	odict_t ivals;
-	/** Total number of used pages. */
-	size_t pages;
-} used_space_t;
-
 /**
  * This structure contains information associated with the shared address space
@@ -193,6 +150,8 @@
 	bool shared;
 
-	/** Complete map of anonymous pages of the shared area. */
-	as_pagemap_t pagemap;
+	/**
+	 * B+tree containing complete map of anonymous pages of the shared area.
+	 */
+	btree_t pagemap;
 
 	/** Address space area backend. */
@@ -262,9 +221,12 @@
 	size_t pages;
 
+	/** Number of resident pages in the area. */
+	size_t resident;
+
 	/** Base address of this area. */
 	uintptr_t base;
 
 	/** Map of used space. */
-	used_space_t used_space;
+	btree_t used_space;
 
 	/**
@@ -321,19 +283,9 @@
 extern as_area_t *as_area_next(as_area_t *);
 
-extern void as_pagemap_initialize(as_pagemap_t *);
-extern void as_pagemap_finalize(as_pagemap_t *);
-extern as_page_mapping_t *as_pagemap_first(as_pagemap_t *);
-extern as_page_mapping_t *as_pagemap_next(as_page_mapping_t *);
-extern errno_t as_pagemap_find(as_pagemap_t *, uintptr_t, uintptr_t *);
-extern void as_pagemap_insert(as_pagemap_t *, uintptr_t, uintptr_t);
-extern void as_pagemap_remove(as_page_mapping_t *);
-
 extern unsigned int as_area_get_flags(as_area_t *);
 extern bool as_area_check_access(as_area_t *, pf_access_t);
 extern size_t as_area_get_size(uintptr_t);
-extern used_space_ival_t *used_space_first(used_space_t *);
-extern used_space_ival_t *used_space_next(used_space_ival_t *);
-extern used_space_ival_t *used_space_find_gteq(used_space_t *, uintptr_t);
-extern bool used_space_insert(used_space_t *, uintptr_t, size_t);
+extern bool used_space_insert(as_area_t *, uintptr_t, size_t);
+extern bool used_space_remove(as_area_t *, uintptr_t, size_t);
 
 /* Interface to be implemented by architectures. */
